--- old/usr/src/tools/smatch/src/smatch_scripts/build_generic_data.sh	Sat Nov 16 11:16:47 2019
+++ new/usr/src/tools/smatch/src/smatch_scripts/build_generic_data.sh	Sat Nov 16 11:16:47 2019
@@ -52,8 +52,15 @@
     fi
 fi
 
-make -j${NR_CPU} CHECK="$BIN_DIR/smatch --call-tree --info --param-mapper --spammy --file-output" $TARGET
+if [[ ! -z $ARCH ]]; then
+	KERNEL_ARCH="ARCH=$ARCH"
+fi
+if [[ ! -z $CROSS_COMPILE ]] ; then
+	KERNEL_CROSS_COMPILE="CROSS_COMPILE=$CROSS_COMPILE"
+fi
 
+make $KERNEL_ARCH $KERNEL_CROSS_COMPILE -j${NR_CPU} CHECK="$BIN_DIR/smatch --call-tree --info --param-mapper --spammy --file-output" $TARGET
+
 find -name \*.c.smatch -exec cat \{\} \; -exec rm \{\} \; > smatch_warns.txt
 
 for i in $SCRIPT_DIR/gen_* ; do
